//+------------------------------------------------------------------+
//|                                                  r-portfolio.mq4 |
//|                               Copyright  2010, Yury V. Reshetov |
//|                                            http://r-portfolio.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Yury V. Reshetov"
#property link      "http://r-portfolio.ru"

//---- input parameters
extern double    p = 0.2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if (! IsTradeAllowed()) {
      Sleep(60000);
      return(0);
   }
   
   double counter = 0.0;
   int ticket = -1;
   double lastlots = 0;
   int total = OrdersTotal();
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderProfit() > 0) {
            ticket = OrderTicket();
            lastlots = OrderLots();
         }
         counter = counter + OrderLots();
      }
   }
   
   RefreshRates();
   
   double lots = ((AccountEquity() + 9750000) * p)  / ((Ask + 2.0 * Point) * MarketInfo(Symbol(), MODE_LOTSIZE)) - counter;
   if (lots > 0) {
      lots = NormalizeDouble(lots, 2);
      if (lots > MarketInfo(Symbol(), MODE_MAXLOT)) {
         lots = MarketInfo(Symbol(), MODE_MAXLOT);
      }
      if (lots < (MarketInfo(Symbol(), MODE_MINLOT) / 2.0)) {
         Sleep(60000);
         return(0);
      }
      //Print("Equity = ", AccountEquity(), ", counter = " + counter);
      OrderSend(Symbol(), OP_BUY, lots, Ask, 2, 0, 0, WindowExpertName(), 0, 0, Blue);
      Sleep(60000);
      return(0); 
   } else {
      if (ticket < 0) {
         Sleep(60000);
         return(0);
      }
      RefreshRates();
      lots = counter - ((AccountEquity()  + 9750000) * p)  / ((Bid - 2.0 * Point) * MarketInfo(Symbol(), MODE_LOTSIZE));
      lots = NormalizeDouble(lots, 2);
      if (lots > lastlots) {
         lots = lastlots;
      }
      if (lots < (MarketInfo(Symbol(), MODE_MINLOT) / 2.0)) {
         Sleep(60000);
         return(0);
      }
      OrderClose(ticket, lots, Bid, 2, Blue);
      Sleep(60000);
      return(0); 
   }
//----
   Sleep(60000);
   return(0);
  }
//+------------------------------------------------------------------+